#include "kanji_union.h"

void versionGuide(double v, bool comments) {
    using namespace std;

    cerr << "dayu Version " << v << "\n" << endl;

    if(comments) {
        cerr << "dayu MS932              # Read MS932 to produce dayu.txt " << endl
            << "dayu MS932 SJIS         # Read MS932 to produce a new file. " << endl
            << "dayu < MS932            # Every line includes 0Dh. " << endl
            << "dayu -b MS932           # Produce binary.tmp " << endl
            << "dayu -b MS932 MS932     # Produce and rename binary.tmp " << endl
            << "dayu -b -y MS932        # Do not remove binary.tmp " << endl
            << "dayu -CRLF MS932        # Every line includes 0Dh. " << endl
            << "dayu -d MS932           # Do not search a table. " << endl
            << "dayu -e- MS932          # Do not edit MS932~Shift_JIS.bin " << endl
            << "dayu -f bars.txt MS932  # Edit MS932~Shift_JIS.bin according to bars.txt " << endl
            << "dayu -i MS932           # Skip control characters except 0Ah. " << endl
            << "dayu -k -aN            #  is subsituted with N. " << endl
            << "dayu -LF MS932          # 0Dh is removed from every line. " << endl
            << "dayu -m@ -sP -r-      # Edit MS932~Shift_JIS.bin without reading MS932 " << endl
            << "dayu -m@ -sP MS932    # @ is subsituted with P. " << endl
            << "dayu -t MS932 SJIS      # MS932 has the same time as SJIS. " << endl
            << "dayu -w MS932           # -w shows which table dayu uses. " << endl
            << "dayu -V                 # version " << endl
            << "dayu -VC                # version with comments " << endl;
    } else {
        cerr << "dayu MS932              " << endl
            << "dayu MS932 SJIS         " << endl
            << "dayu < MS932            " << endl
            << "dayu -b MS932           " << endl
            << "dayu -b MS932 MS932     " << endl
            << "dayu -b -y MS932        " << endl
            << "dayu -CRLF MS932        " << endl
            << "dayu -d MS932           " << endl
            << "dayu -e- MS932          " << endl
            << "dayu -f bars.txt MS932  " << endl
            << "dayu -i MS932           " << endl
            << "dayu -k -aN            " << endl
            << "dayu -LF MS932          " << endl
            << "dayu -m@ -sP -r-      " << endl
            << "dayu -m@ -sP MS932    " << endl
            << "dayu -t MS932 SJIS      " << endl
            << "dayu -w MS932           " << endl
            << "dayu -V                 " << endl
            << "dayu -VC                " << endl;
    }

    exit(1);
}
