#ifndef DIVIDING_H
#define DIVIDING_H

#define CLEAR '0'
#define EDIT_FUNCTION_FACTOR 2
#define FIELD_COUNT 3072
#define MINIMUM_COMBO_SIZE 256
#define NOT_RECOGNIZED -1
#define PATH_NAME_SIZE 255
#define QUOTE '"'
#define SET '1'
#define UNBROKEN_BUFFER_SIZE 524288 // 512 KB
#include <fstream>
#include <iostream>
#include <sstream>
#include <stdio.h>
#include <string.h>
#include <vector>

enum NEW_PHASES {
    BUFFER,
    COMBO,
    SELECTED,
    PHASE_COUNT
};

typedef char* FIELD_POINTER;
typedef FIELD_POINTER (*EDIT_FUNCTION)(FIELD_POINTER p);
typedef std::vector<std::string> FIELDS_ARRAY;

class Dividing {
    bool *selected;
    bool allocated, remove_separators;
    char *buffer;
    char *combo;
    char *pattern;
    FIELDS_ARRAY a;
    int buffer_size, field_count, separator;
    std::string messages;

    bool attempt_to_provide_buffers(bool stop);
    bool full_house_attempt_to_provide_buffers(bool stop);
    void vector_to_array_arranging_in_reverse_order();
    void vector_to_array_complementing(char *extra, int bond);
    void vector_to_array_editing(EDIT_FUNCTION editing, int field_number);
    void vector_to_array_mapping();

public:
    ~Dividing();
    Dividing(int s);
    Dividing(int s, bool r);
    Dividing(int s, char f);
    Dividing(int s, char f, bool r);
    Dividing(int s, int f);
    Dividing(int s, int f, bool r);
    Dividing(long z, int s);
    Dividing(long z, int s, bool r);
    Dividing(long z, int s, char f);
    Dividing(long z, int s, char f, bool r);
    Dividing(long z, int s, int f);
    Dividing(long z, int s, int f, bool r);
    Dividing(char *p, int s, char f);
    Dividing(char *p, int s, char f, bool r);
    Dividing(char *p, int s, int f);
    Dividing(char *p, int s, int f, bool r);
    Dividing(char *p, long z, int s, char f);
    Dividing(char *p, long z, int s, char f, bool r);
    Dividing(char *p, long z, int s, int f);
    Dividing(char *p, long z, int s, int f, bool r);
    int complementing_fields_list(char *p, char *extra, int bond);
    int editing_fields_list(char *p, EDIT_FUNCTION editing, int field_number);
    int mapping_fields_list(char *p);
    int reversing_fields_list(char *p);
    int search_separator(char *p, int beginning);
    int smashed_to_pieces(char *p);
    std::string reverse_unite(char *p);
    std::string unite(char *p);
    std::string unite(char *p, bool listed);
    void unite(FIELDS_ARRAY & a, char *p, char *combo);
};

void supplying_bits(char *p, int *field_count);
void surge_of_set_bits(char *pattern, int field_count, int from, int to);

#endif // DIVIDING_H
