#include "hanzen.h"

void versionGuide(double v, bool comments, bool loud) {
    using namespace std;

    const string NEW_LINE("\n");
    string messages;
    stringstream os;
    os << "hanzen Version " << v << "\n" << NEW_LINE;

    if(comments) {
        os << "hanzen csv                   # Read csv to produce hanzen.txt " << NEW_LINE;
        os << "hanzen csv zenkaku           # Read csv to produce a zenkaku file. " << NEW_LINE;
        os << "hanzen < csv > zenkaku       # Read csv to produce a zenkaku file. " << NEW_LINE;
        os << "hanzen -f3 -e2 csv           # Every line includes 3 fields. Edit Field-2 only. " << NEW_LINE;
        os << "hanzen -f3 -e2 -a_ csv       # Every hankaku-katakana is substituted with a bar." << NEW_LINE;
        os << "hanzen -f3 -e2 -a\\x5F csv   # Every hankaku-katakana is substituted with 5Fh." << NEW_LINE;
        os << "hanzen -f3 -e2 -b\\x0A csv    # Read csv to produce binary.tmp " << NEW_LINE;
        os << "hanzen -f3 -e2 -c- csv       # Skip combining characters. " << NEW_LINE;
        os << "hanzen -f3 -e2 -d csv        # Do not search a table. " << NEW_LINE;
        os << "hanzen -f3 -e2 -i csv        # Skip control characters except 0Ah. " << NEW_LINE;
        os << "hanzen -f3 -e2 -l csv        # Show how large the buffer is. " << NEW_LINE;
        os << "hanzen -f3 -e2 -m csv        # Read csv to produce binary.tmp " << NEW_LINE;
        os << "hanzen -f3 -e2 -q csv        # Commas disappear if placed in quotes. " << NEW_LINE;
        os << "hanzen -f3 -e2 -s, csv       # CSV " << NEW_LINE;
        os << "hanzen -f3 -e2 -s\\l -x- csv  # Do not check if the file name includes .csv " << NEW_LINE;
        os << "hanzen -f3 -e2 -s\\l csv      # Wiki table " << NEW_LINE;
        os << "hanzen -f3 -e2 -s\\x7C csv    # Wiki table " << NEW_LINE;
        os << "hanzen -f3 -e2 -w csv        # -w shows which table hanzen uses. " << NEW_LINE;
        os << "hanzen -f3 -e2 -y csv        # Do not remove binary.tmp " << NEW_LINE;
        os << "hanzen -f3 -e2 -z256 csv     # Use a buffer of 256 bytes. " << NEW_LINE;
        os << "hanzen -f255 -e2 -t wide     # Check if all lines share the field count. " << NEW_LINE;
        os << "hanzen -V                    # version " << NEW_LINE;
        os << "hanzen --help                # Display comments. " << NEW_LINE;
        os << "hanzen -u --help > file      # Produce a help file. ";
    } else {
        os << "hanzen --help ";
    }

    messages = os.str();
    if(loud) {
        cerr << messages << endl;
    } else { // -s
        cout << messages << endl;
    }

    exit(1);
}
