#include "hanzen.h"

/*
hanzen C++ Version 1.14
Replacing hankaku katakana with zenkaku katakana
Copyright 2019 Sogaya

gcc (GCC) 3.4.2 (mingw-special)
Borland C++ 5.5.1 for Win32
Digital Mars Compiler Version 8.42n (Digital Mars C/C++ Compiler Version 8.57)
Embarcadero C++ 7.30 for Win32

*/

char bits[ FIELD_COUNT + 1 ];
int ascii = ASCII_BAR;

bool extensionEqualsCSV(std::string & name) {
    using namespace std;

    bool csv = false;
    const int DOT_SIZE = 1;
    const string CAPITAL_CSV("CSV");
    const string CSV("csv");
    const string DOT(".");

    int q = name.find(DOT);
    string extention;
    if(q >= 0) {
        q += DOT_SIZE;
        extention = name.substr(q);
        if(CSV == extention) {
            csv = true;
        } else if(CAPITAL_CSV == extention) {
            csv = true;
        }

    }

    return csv;
}

int main(int argc, char *argv[]) {
    using namespace std;

    const bool REMOVE_SEPARATOR = false;
    const bool STOP = true;
    const bool WAY_OF_ARRANGING = false;
    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int ABOLISH_KATAKANA_SIZE = 2;
    const int BINARY_TERM_SIZE = 2;
    const int NEW_LINE_ZERO = 2; // buffer shall include '\n' and '\0'.
    const int NOT_CONVERTED = -1;
    const int NOT_FOUND = -1;
    const int SEPARATOR_TERM_SIZE = 2;
    const string ABOLISH_KATAKANA("-a");
    const string ALL_LINES_SHARE_FIELD_COUNT("-t");
    const string BINARY("-b");
    const string DO_NOT_CHECK_EXTENSION("-x-");
    const string DO_NOT_REMOVE_TEMPORARY_BINARY_FILE("-y");
    const string DO_NOT_SEARCH_TABLE("-d");
    const string EMPTY("");
    const string FIELD_COUNT_TERM("-f");
    const string FIELD_NUMBER_TERM("-e");
    const string HELP("--help");
    const string LINE_BUFFER_SIZE("-l");
    const string MONOLITHIC("-m");
    const string NO_COMBINING("-c-");
    const string QUOTES("-q");
    const string SEPARATOR("-s");
    const string SIZE_OF_BUFFER("-z");
    const string SKIPPING("-i");
    const string TABLE("-w");
    const string UNVOICED("-u");
    const string VERSION_WITH_COMMENTS("-VC");
    const string VERSION_WITHOUT_COMMENTS("-V");

    bool abolish_hankaku_katakana = false;
    bool carriage_return = false;
    bool check_extension = true;
    bool check_field_count = false;
    bool combining_character = true;
    bool csv = false;
    bool file_to_be_read = true;
    bool line_buffer_size = false;
    bool loud = true;
    bool no_removing = false;
    bool no_searching = false;
    bool remove_separators = false;
    bool skip_control_characters = false;
    bool temporary_binary = false;
    bool which_table = false;
    char binary_extra = 0x0A;
    char file_name[ FILE_NAME_SIZE + 1 ];
    char MINUS_E2[] = "-e2";
    char new_name[ FILE_NAME_SIZE + 1 ];
    int buffer_size = BUFFER_SIZE;
    int exit_code = 0;
    int field_count = FIELD_COUNT;
    int field_number = 1;
    int file_name_size, line_count, maximum;
    int q = NOT_FOUND;
    int separator = COMMA;
    long z = (long)BUFFER_SIZE;
    Numbered *n = new Numbered(MINUS_E2);
    string *p = new string("");
    string fileName = EMPTY;
    string newName(HANZEN_TEXT);
    string argument;

    memset(bits, SET, FIELD_COUNT);

    for(int i = 1; i < argc; ++i) {
        delete p;
        p = new string(argv[i]);
        argument = *p;

        if(ALL_LINES_SHARE_FIELD_COUNT == argument) {
            check_field_count = true;
        } else if(DO_NOT_CHECK_EXTENSION == argument) {
            check_extension = false;
        } else if(DO_NOT_REMOVE_TEMPORARY_BINARY_FILE == argument) {
            no_removing = true;
        } else if(DO_NOT_SEARCH_TABLE == argument) {
            no_searching = true;
        } else if(HELP == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITH_COMMENTS, loud);
        } else if(LINE_BUFFER_SIZE == argument) {
            line_buffer_size = true;
        } else if(MONOLITHIC == argument) {
            binary_extra = 0x0A;
            temporary_binary = true;
            separator = 0x0D;
        } else if(NO_COMBINING == argument) {
            combining_character = false;
        } else if(QUOTES == argument) {
            remove_separators = true;
        } else if(SKIPPING == argument) {
            skip_control_characters = true;
        } else if(TABLE == argument) {
            which_table = true;
        } else if(UNVOICED == argument) {
            loud = false;
        } else if(VERSION_WITH_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITH_COMMENTS, loud);
        } else if(VERSION_WITHOUT_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITHOUT_COMMENTS, loud);
        } else {
            q = argument.find(ABOLISH_KATAKANA);
            if(q == 0) {
                ascii = punctuation(argv[i], ABOLISH_KATAKANA_SIZE);
                if(ascii > 0x7E) {
                    ascii = ASCII_BAR; // global variable
                }

                abolish_hankaku_katakana = true;
                continue;
            }

            q = argument.find(BINARY);
            if(q == 0) {
                binary_extra = punctuation(argv[i], BINARY_TERM_SIZE);
                temporary_binary = true;
                continue;
            }

            q = argument.find(FIELD_COUNT_TERM);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                field_count = n->number();
                if ( FIELD_COUNT_TERM == n->parameter() ) {
                    if(field_count == NOT_CONVERTED) {
                        field_count = FIELD_COUNT;
                    }

                    continue;
                }

                field_count = FIELD_COUNT;
            }

            q = argument.find(FIELD_NUMBER_TERM);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                field_number = n->number();
                if ( FIELD_NUMBER_TERM == n->parameter() ) {
                    if(field_number == NOT_CONVERTED) {
                        field_number = 1;
                    }

                    continue;
                }

                field_number = 1;
            }

            q = argument.find(SEPARATOR);
            if(q == 0) {
                separator = punctuation(argv[i], SEPARATOR_TERM_SIZE);
                continue;
            }

            q = argument.find(SIZE_OF_BUFFER);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                buffer_size = n->number();
                if ( SIZE_OF_BUFFER == n->parameter() ) {
                    if(buffer_size == NOT_CONVERTED) {
                        buffer_size = BUFFER_SIZE;
                    }

                    continue;
                }

                buffer_size = BUFFER_SIZE;
            }

            if(file_to_be_read) {
                fileName = argument;
                file_to_be_read = false;
            } else {
                newName = argument;
            }

        } // if

    } // for(int i = 1; i < argc; ++i)

    new_name[FILE_NAME_SIZE] = '\0';
    strncpy(new_name, newName.c_str(), FILE_NAME_SIZE);

    file_name[FILE_NAME_SIZE] = '\0';
    strncpy(file_name, fileName.c_str(), FILE_NAME_SIZE);
    file_name_size = strlen(file_name);
    if(file_name_size == 0) {
        z = (long)buffer_size;
        if(line_buffer_size) {
            cout << buffer_size << " bytes" << endl;
        }

        Standard_input *i = new Standard_input(z, separator, field_count, remove_separators, abolish_hankaku_katakana, combining_character, no_searching, skip_control_characters, &which_table);

        if(check_field_count) {
            exit_code = i->standard_input_counting();
        } else {
            exit_code = i->standard_input_output(field_number);
        }

        delete i; delete n; delete p;
        return exit_code;
    }

    Line *e = new Line(fileName);
    line_count = e->checkLineCount(STOP);

    if(buffer_size == BUFFER_SIZE) {
        maximum = e->maximumLineSize();
        buffer_size = maximum + NEW_LINE_ZERO;
    }

    z = (long)buffer_size;
    if(line_buffer_size) {
        cout << buffer_size << " bytes" << endl;
    }

    if(check_extension) {
        csv = extensionEqualsCSV(fileName);
        if(csv) {
            separator = COMMA;
        }

    }

    if(check_field_count) {
        DestroyRebuild *d = new DestroyRebuild(file_name, bits, new_name, z, separator, field_count, REMOVE_SEPARATOR, WAY_OF_ARRANGING);
        exit_code = d->counting();
        delete d;
    } else {
        HankakuZenkaku *d = new HankakuZenkaku(file_name, bits, new_name, z, separator, field_count, remove_separators, WAY_OF_ARRANGING, abolish_hankaku_katakana, combining_character, no_searching, skip_control_characters, &which_table);

        if(temporary_binary) {
// The user can give the file a new name that does not equal HANZEN_TEXT. If new_name equals HANZEN_TEXT, hanzen produces not HANZEN_TEXT but TEMPORARY_BINARY.
            exit_code = d->selecting(field_number, binary_extra);

            if( strcmp(new_name, HANZEN_TEXT) ) {
                renameBinaryFile(new_name, no_removing);
            }

        } else {
            exit_code = d->selecting(field_number);
        }

        delete d;
    }

    delete n; delete p;
    return exit_code;
}

int punctuation(char *p, int q) {
    const int GAP = ' ';
    const int GREATER_THAN = '>';
    const int LESS_THAN = '<';
    const int TAB = '\t';
    const int VERTICAL_LINE = '|';
    const int X_SIZE = 1;
    const int YEN = '\\';
    const int YEN_SIZE = 1;
    char *stop;
    char ASCII_KATAKANA[] = "                                 !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~                                  ";
    char hexadecimal[3] = {0, 0, 0};
    unsigned char uc = (unsigned char)p[q];
    int c = (int)uc;
    int k;
    int separator = COMMA;

    if(c == YEN) {
        q += YEN_SIZE;
        uc = (unsigned char)p[q];
        c = (int)uc;
        switch(c) {
        case 'A':
            return LESS_THAN;
        case HE: // 0xCD
            return LESS_THAN;
        case 'l':
            return VERTICAL_LINE;
        case 's':
            return GAP;
        case 't':
            return TAB;
        case 'v':
            return GREATER_THAN;
        case 'x':
            q += X_SIZE;
            memcpy(hexadecimal, &p[q], 2);
            separator = (int)strtol(hexadecimal, &stop, 16);
            return separator;
        default:
            return COMMA;
        }

    }

    for(k = 0; ASCII_KATAKANA[k]; k++) {
        if(ASCII_KATAKANA[k] == c) {
            separator = k;
        }

    }

    return separator;
}
