#include "hanzen.h"

extern SparseKana *kana;

namespace {
    bool LISTED = true;
    const bool NO_REMOVING = false;
    const int ERROR_CODE = -1;
    const int FIELD_COUNT_0 = 3;
    const int NEW_NAME_ERROR = 2;
    const int SEPARATOR_0 = ',';
    const long BUFFER_SIZE_0 = 6;
    char BITS_0[] = "111";
}

Standard_input::Standard_input(long z, int s, int f, bool r, bool a, bool c, bool g, bool i, bool *which) {
    using namespace std;

    int phase = BUFFER;

    buffer_size = (int)z;
    field_count = f;
    separator = s;

    abolish_hankaku_katakana = a;
    combining_character = c;
    no_searching = g;
    remove_separators = r;
    skip_control_characters = i;
    which_table = which;

    pattern[FIELD_COUNT] = '\0';
    memset(pattern, SET, FIELD_COUNT);

    try {
        buffer = new char[buffer_size];

        phase = COMBO;
        combo = new char[ MINIMUM_COMBO_SIZE + buffer_size ];
    } catch(...) {
        cerr << "new char[] error-8: " << buffer_size << " bytes ( phase = " << phase << " )" << endl;
        exit(1);
    }

}

int Standard_input::standard_input_output(int field_number) {
    using namespace std;

    char *p;
    char few_fields;
    Dividing *d = new Dividing(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    EDIT_FUNCTION removing_katakana = hankaku_zenkaku;
    int exit_code = 0;
    long z = (long)buffer_size;

    kana = new SparseKana(buffer_size);
    if(! kana->setting(no_searching, which_table) ) {
        errorHandler("standard_input_output() error:", "kana->setting(no_searching, which_table)");
        delete d; delete kana;
        return ERROR_CODE;
    }

    if(abolish_hankaku_katakana) {
        removing_katakana = abolish_hankaku;
    } else {
        if(combining_character) {
//            removing_katakana = hankaku_zenkaku;
        } else {
            removing_katakana = replace_hankaku_with_zenkaku_except_dakuten;
        }

    }

    if(field_count <= 0x00FF) { // 0 to 255
        few_fields = (char)field_count;

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(z, separator, few_fields, remove_separators);
            d->editing_fields_list(buffer, removing_katakana, field_number);
            cout << d->unite(buffer, LISTED) << endl;
        }

    } else {
        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(z, separator, field_count, remove_separators);
            d->editing_fields_list(buffer, removing_katakana, field_number);
            cout << d->unite(buffer, LISTED) << endl;
        }

    }

    delete d; delete kana;
    return exit_code;
}
