#include "narfi.h"

static char field[DECIMAL_FIELD_SIZE];
static char head[DECIMAL_FIELD_SIZE];
static char tail[DECIMAL_FIELD_SIZE];
static const int DECIMAL_FIELD_SIZE_1 = DECIMAL_FIELD_SIZE - 1;

FIELD_POINTER extract_decimal(FIELD_POINTER f) {
    char *p;
    char *trace;
    int digit_count;

    field[DECIMAL_FIELD_SIZE_1] = '\0';
    strncpy(field, f, DECIMAL_FIELD_SIZE_1);
    p = strchr(field, '.');
    if(p == NULL) {
        field[0] = '0';
        field[1] = '.';
        field[2] = '0';
        field[3] = '\0';
    } else {
        *p = '\0';
        trace = p;

        p++;
        digit_count = strspn(p, "0123456789");
        memcpy(tail, p, digit_count);
        tail[digit_count] = '\0';

        strcpy(head, field);
        digit_count = strspn( strrev(head), "-0123456789");
        if(digit_count == 0) {
            head[0] = '0';
            head[1] = '\0';
        } else {
            p = trace - digit_count;
            memcpy(head, p, digit_count);
            head[digit_count] = '\0';
        }

        strcpy(field, head);
        strcat(field, ".");
        strcat(field, tail);
    }

    return field;
}

FIELD_POINTER extract_integer(FIELD_POINTER f) {
    char *p;
    char *trace;
    int digit_count, not_found, s;

    field[DECIMAL_FIELD_SIZE_1] = '\0';
    strncpy(field, f, DECIMAL_FIELD_SIZE_1);
    not_found = strlen(field);
    s = strcspn(field, "-0123456789");
    if(s == not_found) {
        field[0] = '0';
        field[1] = '\0';
    } else {
        p = & field[s];
        trace = p;

        if(field[s] == '-') {
            head[0] = field[s];
            head[1] = '\0';

            p++;
            digit_count = strspn(p, "0123456789");
            memcpy(tail, p, digit_count);
            tail[digit_count] = '\0';

            strcpy(field, head);
            strcat(field, tail);
        } else {
            digit_count = strspn(p, "0123456789");
            memcpy(tail, p, digit_count);
            tail[digit_count] = '\0';

            strcpy(field, tail);
        }

    }

    return field;
}

FIELD_POINTER transparent(FIELD_POINTER p) {
    return p;
}

