#include "narfi.h"

/*
narfi C++ Version 1.16
Selecting fields from CSV to produce a narrow file
Copyright 2019 Sogaya

gcc (GCC) 3.4.2 (mingw-special)
Borland C++ 5.5.1 for Win32
Digital Mars Compiler Version 8.42n (Digital Mars C/C++ Compiler Version 8.57)
Embarcadero C++ 7.30 for Win32

*/

char bits[ FIELD_COUNT + 1 ];
KANA_ASCII kana_ascii;
KANA_ASCII *kana = &kana_ascii;

bool extensionEqualsCSV(std::string & name) {
    using namespace std;

    bool csv = false;
    const int DOT_SIZE = 1;
    const string CAPITAL_CSV("CSV");
    const string CSV("csv");
    const string DOT(".");

    int q = name.find(DOT);
    string extention;
    if(q >= 0) {
        q += DOT_SIZE;
        extention = name.substr(q);
        if(CSV == extention) {
            csv = true;
        } else if(CAPITAL_CSV == extention) {
            csv = true;
        }

    }

    return csv;
}

bool setting(KANA_ASCII *kana, long z, int ascii) {
    using namespace std;     

    bool b = true;
    int phase = BUFFER;

    kana->ascii = ascii;
    kana->buffer_size = (int)z;

    try {
        kana->buffer = new char[kana->buffer_size];

        phase = COMBO;
        kana->combo = new char[ kana->buffer_size * ASCII_SIZE ];
    } catch(...) {
        cerr << "new char[] error: " << kana->buffer_size << " bytes ( phase = " << phase << " )" << endl;
        b = false;
    }

    return b;
}

int main(int argc, char *argv[]) {
    using namespace std;

    const bool STOP = true;
    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int A_SUBSTITUTE_TERM_SIZE = 2;
    const int BITS_SIZE = 2;
    const int ERROR_CODE = 1;
    const int NEW_LINE_ZERO = 2; // buffer shall include '\n' and '\0'.
    const int NONE = 0;
    const int NOT_CONVERTED = -1;
    const int NOT_FOUND = -1;
    const int SEPARATOR_TERM_SIZE = 2;
    const string ALL_LINES_SHARE_FIELD_COUNT("-f");
    const string A_SUBSTITUTE("-a");
    const string DO_NOT_CHECK_EXTENSION("-x-");
    const string EMPTY("");
    const string EXTRACT_DECIMAL("-e");
    const string EXTRACT_INTEGER("-n");
    const string FIELD_COUNT_TERM("-c");
    const string INTERVAL("-i");
    const string LINE_BUFFER_SIZE("-l");
    const string QUOTES("-q");
    const string REMOVE_CONTROL("-o");
    const string REPLACE_KATAKANA("-k");
    const string REVERSE("-r");
    const string SEPARATOR("-s");
    const string SIZE_OF_BUFFER("-z");
    const string VERSION_WITH_COMMENTS("-VC");
    const string VERSION_WITHOUT_COMMENTS("-V");

    bool check_extension = true;
    bool check_field_count = false;
    bool csv = false;
    bool file_to_be_read = true;
    bool line_buffer_size = false;
    bool remove_separators = false;
    bool reverse = false;
    bool surge = false;
    char *b;
    char *edge;
    char *supplied;
    char BITS[] = "-b";
    char file_name[ FILE_NAME_SIZE + 1 ];
    char MINUS_E2[] = "-e2";
    char new_name[ FILE_NAME_SIZE + 1 ];
    int ascii = '_'; // 0x5F
    int body_length = 1;
    int buffer_size = BUFFER_SIZE;
    int demands = FIELD_COUNT;
    int direction = 1; // direction > 0
    int edited_field_number = NONE;
    int editing = NEITHER_EXTRACT_NOR_REMOVE;
    int exit_code = 0;
    int field_count = FIELD_COUNT;
    int file_name_size, line_count, maximum;
    int from = 1;
    int interval_0 = from;
    int to = 1;
    int interval_1 = to;
    int q = NOT_FOUND;
    int separator = COMMA;
    long z = (long)BUFFER_SIZE;
    Numbered *n = new Numbered(MINUS_E2);
    string *p = new string("");
    string fileName = EMPTY;
    string newName(NARFI_TEXT);
    string argument;

    for(int i = 1; i < argc; ++i) {
        delete p;
        p = new string(argv[i]);
        argument = *p;

        if(ALL_LINES_SHARE_FIELD_COUNT == argument) {
            check_field_count = true;
        } else if(DO_NOT_CHECK_EXTENSION == argument) {
            check_extension = false;
        } else if(LINE_BUFFER_SIZE == argument) {
            line_buffer_size = true;
        } else if(QUOTES == argument) {
            remove_separators = true;
        } else if(REVERSE == argument) {
            reverse = true;
        } else if(VERSION_WITH_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITH_COMMENTS);
        } else if(VERSION_WITHOUT_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITHOUT_COMMENTS);
        } else {
            b = argv[i];
            edge = & b[0];

            q = argument.find(A_SUBSTITUTE);
            if(q == 0) {
                ascii = punctuation(argv[i], A_SUBSTITUTE_TERM_SIZE);
                continue;
            }

            b = strstr(argv[i], BITS);
            if(b == edge) {
                b += BITS_SIZE;
                body_length = strlen(b);
                if(body_length > field_count) {
                    body_length = field_count;
                    memcpy(bits, b, body_length);
                    bits[body_length] = '\0';
                } else {
                    demands = field_count - body_length;
                    try {
                        supplied = new char[ demands + 1 ];
                        supplied[demands] = '\0';
                        memset(supplied, SET, demands);
                        strcpy(bits, b);
                        strcat(bits, supplied);
                        delete[] supplied;
                    } catch(...) {
                        cerr << "new char[] error-8: " << demands << " bytes" << endl;
                        exit(1);
                    }

                }

                continue;
            }

            q = argument.find(EXTRACT_DECIMAL);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                edited_field_number = n->number();
                if ( EXTRACT_DECIMAL == n->parameter() ) {
                    if(field_count == NOT_CONVERTED) {
                        edited_field_number = NONE;
                        editing = NEITHER_EXTRACT_NOR_REMOVE;
                    } else {
                        editing = EXTRACT_DECIMAL_FROM_FIELD;
                    }

                    continue;
                }

                edited_field_number = NONE;
                editing = NEITHER_EXTRACT_NOR_REMOVE;
            }

            q = argument.find(EXTRACT_INTEGER);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                edited_field_number = n->number();
                if ( EXTRACT_INTEGER == n->parameter() ) {
                    if(edited_field_number == NOT_CONVERTED) {
                        edited_field_number = NONE;
                        editing = NEITHER_EXTRACT_NOR_REMOVE;
                    } else {
                        editing = EXTRACT_INTEGER_FROM_FIELD;
                    }

                    continue;
                }

                edited_field_number = NONE;
                editing = NEITHER_EXTRACT_NOR_REMOVE;
            }

            q = argument.find(FIELD_COUNT_TERM);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                field_count = n->number();
                if ( FIELD_COUNT_TERM == n->parameter() ) {
                    if(field_count == NOT_CONVERTED) {
                        field_count = FIELD_COUNT;
                    }

                    continue;
                }

                field_count = FIELD_COUNT;
            }

            q = argument.find(INTERVAL);
            if(q == 0) {
                delete n;
                n = new Numbered(argument, FIELD_COUNT);
                if( n->trimmed_sequence() ) {
                    interval_1 = n->number();
                    interval_0 = n->subnumber();
                    if( INTERVAL == n->parameter() ) {
                        if(interval_0 == NOT_CONVERTED) {
                            interval_0 = 1;
                            interval_1 = 1;
                        }

                        direction = interval_1 - interval_0;
                        if(direction >= 0) {
                            from = interval_0;
                            to = interval_1;
                            surge = true;
                            continue;
                        } else {
                            from = interval_1;
                            to = interval_0;
                            surge = true;
                            continue;
                        }

                    }

                }

                interval_0 = 1;
                interval_1 = 1;
            }

            q = argument.find(REMOVE_CONTROL);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                edited_field_number = n->number();
                if ( REMOVE_CONTROL == n->parameter() ) {
                    if(edited_field_number == NOT_CONVERTED) {
                        edited_field_number = NONE;
                        editing = NEITHER_EXTRACT_NOR_REMOVE;
                    } else {
                        editing = REMOVE_CONTROL_CHARACTERS_FROM_FIELD;
                    }

                    continue;
                }

                edited_field_number = NONE;
                editing = NEITHER_EXTRACT_NOR_REMOVE;
            }

            q = argument.find(REPLACE_KATAKANA);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                edited_field_number = n->number();
                if ( REPLACE_KATAKANA == n->parameter() ) {
                    if(edited_field_number == NOT_CONVERTED) {
                        edited_field_number = NONE;
                        editing = NEITHER_EXTRACT_NOR_REMOVE;
                    } else {
                        editing = REPLACE_KATAKANA_WITH_ASCII;
                    }

                    continue;
                }

                edited_field_number = NONE;
                editing = NEITHER_EXTRACT_NOR_REMOVE;
            }

            q = argument.find(SEPARATOR);
            if(q == 0) {
                separator = punctuation(argv[i], SEPARATOR_TERM_SIZE);
                continue;
            }

            q = argument.find(SIZE_OF_BUFFER);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                buffer_size = n->number();
                if ( SIZE_OF_BUFFER == n->parameter() ) {
                    if(buffer_size == NOT_CONVERTED) {
                        buffer_size = BUFFER_SIZE;
                    }

                    continue;
                }

                buffer_size = BUFFER_SIZE;
            }

            if(file_to_be_read) {
                fileName = argument;
                file_to_be_read = false;
            } else {
                newName = argument;
            }

        } // if

    } // for(int i = 1; i < argc; ++i)

    if(surge) {
        surge_of_set_bits(bits, field_count, from, to);
    }

    new_name[FILE_NAME_SIZE] = '\0';
    strncpy(new_name, newName.c_str(), FILE_NAME_SIZE);

    file_name[FILE_NAME_SIZE] = '\0';
    strncpy(file_name, fileName.c_str(), FILE_NAME_SIZE);
    file_name_size = strlen(file_name);
    if(file_name_size == 0) {
        z = (long)buffer_size;
        if(line_buffer_size) {
            cout << buffer_size << " bytes" << endl;
        }

        Standard_input *i = new Standard_input(bits, z, separator, field_count, remove_separators, reverse);
        if(edited_field_number == NONE) {
            if(check_field_count) {
                exit_code = i->standard_input_counting();
            } else {
                exit_code = i->standard_input_output();
            }

        } else {
            switch(editing) {
            case REMOVE_CONTROL_CHARACTERS_FROM_FIELD:
                if(! setting(kana, z, ascii) ) {
                    return ERROR_CODE;
                }

                exit_code = i->standard_input_output(edited_field_number, editing);
                detach_buffers(kana);
                break;
            case REPLACE_KATAKANA_WITH_ASCII:
                if(! setting(kana, z, ascii) ) {
                    return ERROR_CODE;
                }

                exit_code = i->standard_input_output(edited_field_number, editing);
                detach_buffers(kana);
                break;
            default:
                exit_code = i->standard_input_output(edited_field_number, editing);
                break;
            }

        }

        delete i; delete n; delete p;
        return exit_code;
    }

    Line *e = new Line(fileName);
    line_count = e->checkLineCount(STOP);

    if(buffer_size == BUFFER_SIZE) {
        maximum = e->maximumLineSize();
        buffer_size = maximum + NEW_LINE_ZERO;
    }

    z = (long)buffer_size;
    if(line_buffer_size) {
        cout << buffer_size << " bytes" << endl;
    }

    if(check_extension) {
        csv = extensionEqualsCSV(fileName);
        if(csv) {
            separator = COMMA;
        }

    }

    DestroyRebuild *r = new DestroyRebuild(file_name, bits, new_name, z, separator, field_count, remove_separators, reverse);
    if(edited_field_number == NONE) {
        if(check_field_count) {
            exit_code = r->counting();
        } else {
            exit_code = r->selecting();
        }

    } else {
        switch(editing) {
        case REMOVE_CONTROL_CHARACTERS_FROM_FIELD:
            if(! setting(kana, z, ascii) ) {
                return ERROR_CODE;
            }

            exit_code = r->selecting(edited_field_number, editing);
            detach_buffers(kana);
            break;
        case REPLACE_KATAKANA_WITH_ASCII:
            if(! setting(kana, z, ascii) ) {
                return ERROR_CODE;
            }

            exit_code = r->selecting(edited_field_number, editing);
            detach_buffers(kana);
            break;
        default:
            exit_code = r->selecting(edited_field_number, editing);
            break;
        }

    }

    delete r; delete n; delete p;
    return exit_code;
}

int punctuation(char *p, int q) {
    const int GAP = ' ';
    const int GREATER_THAN = '>';
    const int LESS_THAN = '<';
    const int TAB = '\t';
    const int VERTICAL_LINE = '|';
    const int X_SIZE = 1;
    const int YEN = '\\';
    const int YEN_SIZE = 1;
    char *stop;
    char ASCII_KATAKANA[] = "                                 !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~                                  ";
    char hexadecimal[3] = {0, 0, 0};
    unsigned char uc = (unsigned char)p[q];
    int c = (int)uc;
    int k;
    int separator = COMMA;

    if(c == YEN) {
        q += YEN_SIZE;
        uc = (unsigned char)p[q];
        c = (int)uc;
        switch(c) {
        case 'A':
            return LESS_THAN;
        case HE: // 0xCD
            return LESS_THAN;
        case 'l':
            return VERTICAL_LINE;
        case 's':
            return GAP;
        case 't':
            return TAB;
        case 'v':
            return GREATER_THAN;
        case 'x':
            q += X_SIZE;
            memcpy(hexadecimal, &p[q], 2);
            separator = (int)strtol(hexadecimal, &stop, 16);
            return separator;
        default:
            return COMMA;
        }

    }

    for(k = 0; ASCII_KATAKANA[k]; k++) {
        if(ASCII_KATAKANA[k] == c) {
            separator = k;
        }

    }

    return separator;
}
