#include "narfi.h"

namespace {
    bool LISTED = true;
    const bool NO_REMOVING = false;
    const int ERROR_CODE = -1;
    const int FIELD_COUNT_0 = 3;
    const int NEW_NAME_ERROR = 2;
    const int SEPARATOR_0 = ',';
    const long BUFFER_SIZE_0 = 6;
    char BITS_0[] = "111";
}

Standard_input::Standard_input(char *b, long z, int s, int f, bool r, bool w) {
    using namespace std;

    int phase = BUFFER;

    buffer_size = (int)z;
    field_count = f;
    remove_separators = r;
    separator = s;
    way_of_arranging = w;

    pattern[FIELD_COUNT] = '\0';
    strncpy(pattern, b, FIELD_COUNT);

    char *p = strchr(pattern, CLEAR);
    full_house = (p == NULL) ? true : false;

    try {
        buffer = new char[buffer_size];

        phase = COMBO;
        combo = new char[ MINIMUM_COMBO_SIZE + buffer_size ];
    } catch(...) {
        cerr << "new char[] error-9: " << buffer_size << " bytes ( phase = " << phase << " )" << endl;
        exit(1);
    }

}

int Standard_input::standard_input_output() {
    using namespace std;

    char *p;
    char few_fields;
    Dividing *d = new Dividing(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    int exit_code = 0;
    long z = (long)buffer_size;

    if(way_of_arranging) {
//        full_house = true;

        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Dividing(z, separator, few_fields, remove_separators);
                cout << d->reverse_unite(buffer) << endl;
            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Dividing(z, separator, field_count, remove_separators);
                cout << d->reverse_unite(buffer) << endl;
            }

        }

    } else {
        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Dividing(z, separator, few_fields, remove_separators);
                    cout << d->unite(buffer) << endl;
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Dividing(pattern, z, separator, few_fields, remove_separators);
                    cout << d->unite(buffer) << endl;
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Dividing(pattern, z, separator, field_count, remove_separators);
                cout << d->unite(buffer) << endl;
            }

        }

    }

    delete d;
    return exit_code;
}

int Standard_input::standard_input_output(int field_number, int editing) {
    using namespace std;

    char *p;
    char few_fields;
    Dividing *d = new Dividing(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    EDIT_FUNCTION extracting = extract_decimal;
    int exit_code = 0;
    long z = (long)buffer_size;

    switch(editing) {
    case NEITHER_EXTRACT_NOR_REMOVE:
        extracting = transparent;
        break;
    case EXTRACT_DECIMAL_FROM_FIELD:
//        extracting = extract_decimal;
        break;
    case EXTRACT_INTEGER_FROM_FIELD:
        extracting = extract_integer;
        break;
    case REMOVE_CONTROL_CHARACTERS_FROM_FIELD:
        extracting = remove_control;
        break;
    case REPLACE_KATAKANA_WITH_ASCII:
        extracting = skip_control_characters_to_abolish_hankaku;
        break;
    default:
        extracting = extract_decimal;
        break;
    }

    if(field_count <= 0x00FF) { // 0 to 255
        few_fields = (char)field_count;

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(z, separator, few_fields, remove_separators);
            d->editing_fields_list(buffer, extracting, field_number);
            cout << d->unite(buffer, LISTED) << endl;
        }

    } else {
        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(z, separator, field_count, remove_separators);
            d->editing_fields_list(buffer, extracting, field_number);
            cout << d->unite(buffer, LISTED) << endl;
        }

    }

    delete d;
    return exit_code;
}
