#ifndef RUFEOL_H
#define RUFEOL_H

#ifdef __BORLANDC__
#pragma warn -8004
#endif

#define VERSION 1.065
#define BLOCK_SIZE 2560
#define BUFFER_SIZE 524288 // 512 KB
#define END_OF_FILE 2
#define ERROR_TEXT "error.txt"
#define FILE_ERROR -1L
#define FILE_ERROR_CODE -2
#define FILE_NAME_SIZE 255
#define FULL_LEVEL 1
#define RUFEOL_TEXT "draft.txt"
#define TAIL_LENGTH 1
#define TEMPORARY_BINARY "binary.tmp"
#include <fstream>
#include <iostream>
#include <deque>
#include <sstream>
#include <string>
#include "Numbered.h"

typedef std::deque<char> RING;

int renameBinaryFile(const char *name, bool no_removing);
void errorHandler(const char *p, const char *q);
void errorHandler(const char *p, std::string & q);
void versionGuide(double v, bool comments);

class RemoveFromLine {
    const int LF_SIZE;

    char *buffer;
    char *combo;
    char BELL;
    int bufferSize, fullLevel, ring_count, size, unnecessary;
    long file_size;
    RING ring;
    std::string fileName, newLine;

    bool ringBeginsWithBell(char *p);
    void prepareRing();

public:
    long fileSize() {
        long size = FILE_ERROR;
        FILE *p = fopen( fileName.c_str(), "rb");
        if(p == NULL) {
            errorHandler("fopen() error:", fileName);
            return size;
        }

        fseek(p, 0, END_OF_FILE);
        size = ftell(p);
        if( size < 0L ) {
            errorHandler("ftell() error:", fileName);
        }

        fclose(p);
        return size;
    }

    RemoveFromLine(std::string & f, int b, int l, int u): BELL(0x07), LF_SIZE(1) {
        bufferSize = b;
        fileName = f;
        fullLevel = l;
        unnecessary = u;

        file_size = fileSize();
        if(file_size == FILE_ERROR) {
            buffer = NULL;
        } else {
            size = (int)file_size;
            if(bufferSize > size) {
                bufferSize = size;
            }

            buffer = new char[bufferSize];
            combo = new char[bufferSize];
        }

    }

    ~RemoveFromLine() {
        delete[] buffer;
        delete[] combo;
    }

    bool insertLF();
    bool insertCRLF();
};

#endif // RUFEOL_H
