#include "rufeol.h"

/*
rufeol Version 1.065
Copyright 2019 Sogaya
Removing unnecessary characters from every end of line
RUFEOL (Removing Unnecessary characters From every End Of Line)

gcc (GCC) 3.4.2 (mingw-special)
Digital Mars C/C++ Compiler Version 8.57, STLport 4.5.3
Borland C++ 5.5.1 for Win32

*/

int main(int argc, char *argv[]) {
    using namespace std;

    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int ERROR_CODE = 1;
    const int NOT_CONVERTED = -1;
    const int NOT_FOUND = -1;
    const string CARRIAGE_RETURN("-r");
    const string CRLF("-CRLF");
    const string DO_NOT_REMOVE_TEMPORARY_BINARY_FILE("-y");
    const string DOUBLE_SPACED("-x");
    const string HELP("--help");
    const string LEVEL_TERM("-w");
    const string MONOLITHIC("-m");
    const string UNNECESSARY("-u");
    const string VERSION_WITHOUT_COMMENTS("-V");
    const string VERSION_WITH_COMMENTS("-VC");

    bool carriageReturn = false;
    bool file_to_be_read = true;
    bool no_removing = false;
    bool result = true;
    char file_name[ FILE_NAME_SIZE + 1 ];
    char MINUS_U3[] = "-u3";
    char new_name[ FILE_NAME_SIZE + 1 ];
    int bufferSize = BUFFER_SIZE;
    int exit_code = 0;
    int file_name_size = 0;
    int fullLevel = FULL_LEVEL;
    int q = NOT_FOUND;
    int unnecessaryWidth = TAIL_LENGTH;
    Numbered *n = new Numbered(MINUS_U3);
    string *p = new string("");
    string fileName("");
    string newName(RUFEOL_TEXT);
    string argument;

    for(int i = 1; i < argc; ++i) {
        delete p;
        p = new string(argv[i]);
        argument = *p;

        if(CARRIAGE_RETURN == argument) {
            carriageReturn = true;
        } else if(CRLF == argument) {
            carriageReturn = true;
        } else if(DO_NOT_REMOVE_TEMPORARY_BINARY_FILE == argument) {
            no_removing = true;
        } else if(HELP == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITH_COMMENTS);
        } else if(MONOLITHIC == argument) {
            carriageReturn = true;
            unnecessaryWidth = 2;
        } else if(VERSION_WITH_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITH_COMMENTS);
        } else if(VERSION_WITHOUT_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITHOUT_COMMENTS);
        } else {
            q = argument.find(DOUBLE_SPACED);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                fullLevel = n->number();
                if( DOUBLE_SPACED == n->parameter() ) {
                    if(fullLevel == NOT_CONVERTED) {
                        fullLevel = FULL_LEVEL;
                    }

                    carriageReturn = true;
                    unnecessaryWidth = fullLevel * 2 - 1;
                    continue;
                }

                fullLevel = FULL_LEVEL;
            }

            q = argument.find(LEVEL_TERM);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                fullLevel = n->number();
                if( LEVEL_TERM == n->parameter() ) {
                    if(fullLevel == NOT_CONVERTED) {
                        fullLevel = FULL_LEVEL;
                    }

                    continue;
                }

                fullLevel = FULL_LEVEL;
            }

            q = argument.find(UNNECESSARY);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                unnecessaryWidth = n->number();
                if( UNNECESSARY == n->parameter() ) {
                    if(unnecessaryWidth == NOT_CONVERTED) {
                        unnecessaryWidth = TAIL_LENGTH;
                    }

                    continue;
                }

                unnecessaryWidth = TAIL_LENGTH;
            }

            if(file_to_be_read) {
                fileName = argument;
                file_to_be_read = false;
            } else {
                newName = argument;
            }

        } // else

    } // for(int i = 1; i < argc; ++i)

    new_name[FILE_NAME_SIZE] = '\0';
    strncpy(new_name, newName.c_str(), FILE_NAME_SIZE);

    file_name[FILE_NAME_SIZE] = '\0';
    strncpy(file_name, fileName.c_str(), FILE_NAME_SIZE);
    file_name_size = strlen(file_name);
    if(file_name_size == 0) {
        cerr << "strlen() error: " << file_name_size << endl;
        cerr << "\nrufeol --help" << endl;
        return ERROR_CODE;
    }

    RemoveFromLine *r = new RemoveFromLine(fileName, bufferSize, fullLevel, unnecessaryWidth);
    if(carriageReturn) {
        result = r->insertCRLF();
    } else {
        result = r->insertLF();
    }

    if(result) {
        exit_code = renameBinaryFile(new_name, no_removing);
    }

    delete n; delete p; delete r;
    return exit_code;
}
