#include "sutai.h"

void versionGuide(double v, bool comments, bool loud) {
    using namespace std;

    const string NEW_LINE("\n");
    string messages;
    stringstream os;
    os << "sortk C++ Version " << v << "\n" << NEW_LINE;

    if(comments) {
        os << "sortk -t, -o new csv       # Read csv to produce a new file. " << NEW_LINE;
        os << "sortk -t, < csv > new      # Read csv to produce a new file. " << NEW_LINE;
        os << "sortk -t, -a4 -h1011 csv   # Compare in Field-1, Field-3 and Field-4. " << NEW_LINE;
        os << "sortk -t, -j2 csv          # Compare phrases in Field-2. " << NEW_LINE;
        os << "sortk -t, -k2,2 csv        # Compare phrases in Field-2. " << NEW_LINE;
        os << "sortk -t, -k2,3 csv        # Compare phrases from Field-2 to Field-3. " << NEW_LINE;
        os << "sortk -t, -k2 csv          # Compare phrases from Field-2 to finish. " << NEW_LINE;
        os << "sortk -t, -k1 -$ csv       # Check if all lines share the field count. " << NEW_LINE;
        os << "sortk -t, -k2,2 -# csv     # Add ID to each summary. " << NEW_LINE;
        os << "sortk -t, -k2,3 -# -! csv  # Report ID if any summaries match each other. " << NEW_LINE;
        os << "sortk -t, -k2,2 -8 csv     # UTF-8 " << NEW_LINE;
        os << "sortk -t, -k2,2 -b csv     # Skip space in the first part of Field-2. " << NEW_LINE;
        os << "sortk -t, -k2,2 -c- csv    # Skip combining characters. " << NEW_LINE;
        os << "sortk -t, -k2,2 -e csv     # EUC-JP " << NEW_LINE;
        os << "sortk -t, -k2,2 -f csv     # EIGHT equals eight. " << NEW_LINE;
        os << "sortk -t, -k2,2 -g csv     # Compare 0.12 with 0.78 in Field-2. " << NEW_LINE;
        os << "sortk -t, -k2,2 -i csv     # Skip control characters. " << NEW_LINE;
        os << "sortk -t, -k2,2 -l csv     # Show how large the buffer is. " << NEW_LINE;
        os << "sortk -t, -k2,2 -n csv     # Compare 3456 with 9012 in Field-2. " << NEW_LINE;
        os << "sortk -t, -k2,2 -p csv     # P and Q are omitted from ASCII characters. " << NEW_LINE;
        os << "sortk -t, -k2,2 -q csv     # Commas disappear if placed in quotes. " << NEW_LINE;
        os << "sortk -t, -k2,2 -r csv     # Arrange in descending order. " << NEW_LINE;
        os << "sortk -t, -k2,2 -u csv     # Display a line for each unique summary. " << NEW_LINE;
        os << "sortk -t, -k2,2 -y csv     # Do not remove binary.tmp " << NEW_LINE;
        os << "sortk -t, -k2,2 -y -% csv  # Produce manager.txt " << NEW_LINE;
        os << "sortk -t, -k2,2 -z256 csv  # Use a buffer of 256 bytes. " << NEW_LINE;
        os << "sortk -t\\l -k2,2 file      # Wiki table " << NEW_LINE;
        os << "sortk -t\\l -k2,2 -x- csv   # Do not check if the file name includes .csv " << NEW_LINE;
        os << "sortk -t\\x7C -k2,2 file    # Wiki table " << NEW_LINE;
        os << "sortk -U131072 -k2,2 csv   # The number of lines shall not exceed 131072. " << NEW_LINE;
        os << "sortk -v\\x1F -k2,3 csv     # 1Fh connects phrases from Field-2 to Field-3. " << NEW_LINE;
        os << "sortk -w~ -k2,4 csv        # ~ is used as a quote. " << NEW_LINE;
        os << "sortk -V                   # version " << NEW_LINE;
        os << "sortk --help               # Display comments. " << NEW_LINE;
        os << "sortk -s --help > file     # Produce a help file. ";
    } else {
        os << "sortk --help ";
    }

    messages = os.str();
    if(loud) {
        cerr << messages << endl;
    } else { // -s
        cout << messages << endl;
    }

    exit(1);
}
