#ifndef SEGMENTED_H
#define SEGMENTED_H

#define BELL 0x07
#define CLEAR '0'
#define FIELD_COUNT 3072
#define MINIMUM_COMBO_SIZE 256
#define NOT_RECOGNIZED -1
#define PATH_NAME_SIZE 255
#define QUOTE '"'
#define SET '1'
#define UNBROKEN_BUFFER_SIZE 524288 // 512 KB
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>

enum NEW_PHASES {
    BUFFER,
    COMBO,
    SELECTED,
    PHASE_COUNT
};

class Segmented {
    bool *selected;
    bool allocated, remove_separators;
    char *buffer;
    char pattern[ FIELD_COUNT + 1 ];
    std::string messages;
    int buffer_size, dakuten, field_count, handakuten, quote, separator;

    bool attempt_to_provide_buffers(bool stop);
    bool full_house_attempt_to_provide_buffers(bool stop);

public:
    char *combo;
    int joint;

    void setting(int j, int q) {
        dakuten = 0xDE;
        handakuten = 0xDF;
        joint = j;
        quote = q;
    }

    int search_separator(char *p, int beginning);
    int segmented_summary(char *p);
    int segmented_summary(char *p, int d, int h);
    ~Segmented();
    Segmented(int s);
    Segmented(int s, bool r);
    Segmented(int s, char f);
    Segmented(int s, char f, bool r);
    Segmented(int s, int f);
    Segmented(int s, int f, bool r);
    Segmented(long z, int s);
    Segmented(long z, int s, bool r);
    Segmented(long z, int s, char f);
    Segmented(long z, int s, char f, bool r);
    Segmented(long z, int s, int f);
    Segmented(long z, int s, int f, bool r);
    Segmented(char *p, int s, char f);
    Segmented(char *p, int s, char f, bool r);
    Segmented(char *p, int s, int f);
    Segmented(char *p, int s, int f, bool r);
    Segmented(char *p, long z, int s, char f);
    Segmented(char *p, long z, int s, char f, bool r);
    Segmented(char *p, long z, int s, int f);
    Segmented(char *p, long z, int s, int f, bool r);
};

void supplying_bits(char *p, int *field_count);
void surge_of_set_bits(char *pattern, int field_count, int from, int to);

#endif // SEGMENTED_H
