#include "sutai.h"

namespace {
    const bool NO_REMOVING = false;
    const int ERROR_CODE = -1;
    const int FIELD_COUNT_0 = 3;
    const int SEPARATOR_0 = ',';
    const long BUFFER_SIZE_0 = 6;
    char BITS_0[] = "111";
}

int SummaryDetails::counting() {
    using namespace std;

    char *p;
    char few_fields;
    int f, shared_field_count;
    int line_count = 0;
    long z = (long)buffer_size;
    Segmented *d = new Segmented(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    FILE *file = fopen(file_name, "rt");
    if(file == NULL) {
        errorHandler("fopen() error-5:", file_name);
        return ERROR_CODE;
    }

    if(field_count <= 0x00FF) { // 0 to 255
        few_fields = (char)field_count;

        p = fgets(buffer, buffer_size, file);
        if(p == NULL) {
            return ERROR_CODE;
        }

        delete d;
        d = new Segmented(z, separator, few_fields, remove_separators);
        d->setting(joint, quote);
        shared_field_count = d->segmented_summary(buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            line_count += 1;
            if(line_count > upper_limit) {
                break;
            }

            delete d;
            d = new Segmented(z, separator, few_fields, remove_separators);
            d->setting(joint, quote);
            f = d->segmented_summary(buffer);
            if(f != shared_field_count) {
                cout << buffer;
            }

        }

    } else {
        p = fgets(buffer, buffer_size, file);
        if(p == NULL) {
            return ERROR_CODE;
        }

        delete d;
        d = new Segmented(pattern, z, separator, field_count, remove_separators);
        d->setting(joint, quote);
        shared_field_count = d->segmented_summary(buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            line_count += 1;
            if(line_count > upper_limit) {
                break;
            }

            delete d;
            d = new Segmented(pattern, z, separator, field_count, remove_separators);
            d->setting(joint, quote);
            f = d->segmented_summary(buffer);
            if(f != shared_field_count) {
                cout << buffer;
            }

        }

    }

    delete d;
    fclose(file);
    return line_count;
}

int Standard_input::standard_input_counting() {
    using namespace std;

    char *p;
    char few_fields;
    int f, shared_field_count;
    int line_count = 0;
    long z = (long)buffer_size;
    Segmented *d = new Segmented(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);

    if(field_count <= 0x00FF) { // 0 to 255
        few_fields = (char)field_count;

        p = fgets(buffer, buffer_size, stdin);
        if(p == NULL) {
            return ERROR_CODE;
        }

        delete d;
        d = new Segmented(z, separator, few_fields, remove_separators);
        d->setting(joint, quote);
        shared_field_count = d->segmented_summary(buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            line_count += 1;
            if(line_count > upper_limit) {
                break;
            }

            delete d;
            d = new Segmented(z, separator, few_fields, remove_separators);
            d->setting(joint, quote);
            f = d->segmented_summary(buffer);
            if(f != shared_field_count) {
                cout << buffer;
            }

        }

    } else {
        p = fgets(buffer, buffer_size, stdin);
        if(p == NULL) {
            return ERROR_CODE;
        }

        delete d;
        d = new Segmented(pattern, z, separator, field_count, remove_separators);
        d->setting(joint, quote);
        shared_field_count = d->segmented_summary(buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            line_count += 1;
            if(line_count > upper_limit) {
                break;
            }

            delete d;
            d = new Segmented(pattern, z, separator, field_count, remove_separators);
            d->setting(joint, quote);
            f = d->segmented_summary(buffer);
            if(f != shared_field_count) {
                cout << buffer;
            }

        }

    }

    delete d;
    return line_count;
}

