#include "sutai.h"

extern DOUBLE_UNION ZEROED;

namespace {
    const bool NO_REMOVING = false;
    const int ERROR_CODE = -1;
    const int FIELD_COUNT_0 = 3;
    const int NEW_PATTERN_BEGINS_WITH_SET_BIT = 1;
    const int SEPARATOR_0 = ',';
    const long BUFFER_SIZE_0 = 6;
    char BITS_0[] = "111";
}

int run_length_encoding(DOUBLE_UNION *u, char *combo, int combo_size) {
    char set_bit = NEW_PATTERN_BEGINS_WITH_SET_BIT; // Because run_length_encoding() adds a set bit to the pattern, a decoder shall omit the set bit.
    char clear_bit = 0;
    int b, m;
    int n = 0;
    unsigned int msb = 0x80000000;
    const int MSB = (int)msb;

    memset(combo, 0, combo_size);
    for(int k = 0; k < INTEGER_ARRAY_SIZE; ++k) {
        m = u->n[k];

        for(int i = 0; i < PATTERN_OF_32_BITS; ++i) {
            b = m & MSB;
            if(b == MSB) {
                if(clear_bit) {
                    combo[n++] = clear_bit;
                    clear_bit = 0;
                }

                set_bit += 1;
            } else {
                if(set_bit) {
                    combo[n++] = set_bit;
                    set_bit = 0;
                }

                clear_bit += 1;
            }

            m = m << 1;
        }

    }

    if(clear_bit) {
        combo[n++] = clear_bit;
    }

    if(set_bit) {
        combo[n++] = set_bit;
    }

    return n;
}

int Standard_input::standard_input_line_for_each_summary() {
    using namespace std;

    char *p;
    char few_fields;
    char combo[MAXIMUM_SIZE_OF_ENCODED_PATTERN];
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    long z = (long)buffer_size;
    Segmented *d = new Segmented(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    int buffer_size_1 = buffer_size - 1;
    int combo_size = sizeof(combo);
    int dakuten = 0xDE;
    int handakuten = 0xDF;
    int line_count = 0;
    set<string> m;
    string *q = new string("");
    unsigned int count;
    FILE *binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        cerr << "fopen() error-6: " << TEMPORARY_BINARY << endl;
        return ERROR_CODE;
    }

    record_size = END + buffer_size;
    if(record_size > BLOCK_SIZE) {
        cerr << "record_size > BLOCK_SIZE error: " << record_size << " bytes" << endl;
        return ERROR_CODE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
//                building_double_array = copying_summary;
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    run_length_encoding(n, combo, combo_size);
                    delete q;
                    q = new string(combo);
                    count = m.size();
                    m.insert(*q);
                    if( m.size() > count ) {
                        p = & n->c[END];
                        p[buffer_size_1] = '\0';
                        strncpy(p, buffer, buffer_size_1); // details

                        fwrite(n->c, record_size, 1, binary_file);
                        line_count += 1;
                        if(line_count > upper_limit) {
                            break;
                        }

                    }

                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    run_length_encoding(n, combo, combo_size);
                    delete q;
                    q = new string(combo);
                    count = m.size();
                    m.insert(*q);
                    if( m.size() > count ) {
                        p = & n->c[END];
                        p[buffer_size_1] = '\0';
                        strncpy(p, buffer, buffer_size_1); // details

                        fwrite(n->c, record_size, 1, binary_file);
                        line_count += 1;
                        if(line_count > upper_limit) {
                            break;
                        }

                    }

                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer);
                building_double_array(n, d); // summary

                run_length_encoding(n, combo, combo_size);
                delete q;
                q = new string(combo);
                count = m.size();
                m.insert(*q);
                if( m.size() > count ) {
                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                }

            }

        }

    } else {
        if(substituted) {
            dakuten = 'P';
            handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    run_length_encoding(n, combo, combo_size);
                    delete q;
                    q = new string(combo);
                    count = m.size();
                    m.insert(*q);
                    if( m.size() > count ) {
                        p = & n->c[END];
                        p[buffer_size_1] = '\0';
                        strncpy(p, buffer, buffer_size_1); // details

                        fwrite(n->c, record_size, 1, binary_file);
                        line_count += 1;
                        if(line_count > upper_limit) {
                            break;
                        }

                    }

                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    run_length_encoding(n, combo, combo_size);
                    delete q;
                    q = new string(combo);
                    count = m.size();
                    m.insert(*q);
                    if( m.size() > count ) {
                        p = & n->c[END];
                        p[buffer_size_1] = '\0';
                        strncpy(p, buffer, buffer_size_1); // details

                        fwrite(n->c, record_size, 1, binary_file);
                        line_count += 1;
                        if(line_count > upper_limit) {
                            break;
                        }

                    }

                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer, dakuten, handakuten);
                building_double_array(n, d); // summary

                run_length_encoding(n, combo, combo_size);
                delete q;
                q = new string(combo);
                count = m.size();
                m.insert(*q);
                if( m.size() > count ) {
                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                }

            }

        }

    }

    delete d; delete q;
    fclose(binary_file);
    return line_count;
}

int SummaryDetails::line_for_each_summary() {
    using namespace std;

    char *p;
    char few_fields;
    char combo[MAXIMUM_SIZE_OF_ENCODED_PATTERN];
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    long z = (long)buffer_size;
    Segmented *d = new Segmented(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    FILE *file;
    int buffer_size_1 = buffer_size - 1;
    int combo_size = sizeof(combo);
    int dakuten = 0xDE;
    int handakuten = 0xDF;
    int line_count = 0;
    set<string> m;
    string *q = new string("");
    unsigned int count;
    FILE *binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        cerr << "fopen() error-7: " << TEMPORARY_BINARY << endl;
        return ERROR_CODE;
    }

    record_size = END + buffer_size;
    if(record_size > BLOCK_SIZE) {
        cerr << "record_size > BLOCK_SIZE error: " << record_size << " bytes" << endl;
        return ERROR_CODE;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        errorHandler("fopen() error-8:", file_name);
        return ERROR_CODE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
//                building_double_array = copying_summary;
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    run_length_encoding(n, combo, combo_size);
                    delete q;
                    q = new string(combo);
                    count = m.size();
                    m.insert(*q);
                    if( m.size() > count ) {
                        p = & n->c[END];
                        p[buffer_size_1] = '\0';
                        strncpy(p, buffer, buffer_size_1); // details

                        fwrite(n->c, record_size, 1, binary_file);
                        line_count += 1;
                        if(line_count > upper_limit) {
                            break;
                        }

                    }

                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    run_length_encoding(n, combo, combo_size);
                    delete q;
                    q = new string(combo);
                    count = m.size();
                    m.insert(*q);
                    if( m.size() > count ) {
                        p = & n->c[END];
                        p[buffer_size_1] = '\0';
                        strncpy(p, buffer, buffer_size_1); // details

                        fwrite(n->c, record_size, 1, binary_file);
                        line_count += 1;
                        if(line_count > upper_limit) {
                            break;
                        }

                    }

                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer);
                building_double_array(n, d); // summary

                run_length_encoding(n, combo, combo_size);
                delete q;
                q = new string(combo);
                count = m.size();
                m.insert(*q);
                if( m.size() > count ) {
                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                }

            }

        }

    } else {
        if(substituted) {
            dakuten = 'P';
            handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    run_length_encoding(n, combo, combo_size);
                    delete q;
                    q = new string(combo);
                    count = m.size();
                    m.insert(*q);
                    if( m.size() > count ) {
                        p = & n->c[END];
                        p[buffer_size_1] = '\0';
                        strncpy(p, buffer, buffer_size_1); // details

                        fwrite(n->c, record_size, 1, binary_file);
                        line_count += 1;
                        if(line_count > upper_limit) {
                            break;
                        }

                    }

                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    run_length_encoding(n, combo, combo_size);
                    delete q;
                    q = new string(combo);
                    count = m.size();
                    m.insert(*q);
                    if( m.size() > count ) {
                        p = & n->c[END];
                        p[buffer_size_1] = '\0';
                        strncpy(p, buffer, buffer_size_1); // details

                        fwrite(n->c, record_size, 1, binary_file);
                        line_count += 1;
                        if(line_count > upper_limit) {
                            break;
                        }

                    }

                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer, dakuten, handakuten);
                building_double_array(n, d); // summary

                run_length_encoding(n, combo, combo_size);
                delete q;
                q = new string(combo);
                count = m.size();
                m.insert(*q);
                if( m.size() > count ) {
                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                }

            }

        }

    }

    delete d; delete q;
    fclose(file);
    fclose(binary_file);
    return line_count;
}

