#include "sutai.h"

int BELL_ASCII_KATAKANA[BELL_ASCII_KATAKANA_COUNT] = {
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 
    0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F, 
    0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F, 
    0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, 
    0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F, 
    0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, 
    0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x07, 
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 
    0x07, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6, 0xA7, 0xA8, 0xA9, 0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF, 
    0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6, 0xB7, 0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0xBE, 0xBF, 
    0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 
    0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0xDF
};

extern DOUBLE_UNION ZEROED;

namespace {
    const bool NO_REMOVING = false;
    const int ERROR_CODE = -1;
    const int FIELD_COUNT_0 = 3;
    const int SEPARATOR_0 = ',';
    const long BUFFER_SIZE_0 = 6;
    char BITS_0[] = "111";
    char GAP[] = " ";
    char sjis[END];
}

SummaryDetails::SummaryDetails(char *e, char *b, char *w, long z, int s, int f, int j, int m, int q, int u, bool a, bool c, bool r, bool k, bool t, bool i, bool g, bool v, bool n) {
    strcpy(file_name, e);

    strcpy(new_name, w);
    buffer_size = (int)z;
    separator = s;
    field_count = f;
    joint = j;
    manager = m;
    quote = q;
    upper_limit = u;
    assume_shift_jis_appears = a;
    combining_character = c;
    remove_separators = r;
    skip_space = k;
    substituted = t;
    add_ID = i;
    carriage_return = g;
    case_sensitive = v;
    descending = n;

    pattern[FIELD_COUNT] = '\0';
    strncpy(pattern, b, FIELD_COUNT);

    char *p = strchr(pattern, CLEAR);
    full_house = (p == NULL) ? true : false;

    try {
        buffer = new char[buffer_size];
    } catch(...) {
        errorHandler("new char[] error-1:", buffer_size, "bytes");
        buffer_size = BLOCK_SIZE;
        buffer = new char[buffer_size];
    }

}

int SummaryDetails::selecting() {
    using namespace std;

    char *p;
    char few_fields;
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    long z = (long)buffer_size;
    Segmented *d = new Segmented(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    FILE *file;
    int buffer_size_1 = buffer_size - 1;
    int dakuten = 0xDE;
    int handakuten = 0xDF;
    int line_count = 0;
    FILE *binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        cerr << "fopen() error-11: " << TEMPORARY_BINARY << endl;
        return ERROR_CODE;
    }

    record_size = END + buffer_size;
    if(record_size > BLOCK_SIZE) {
        cerr << "record_size > BLOCK_SIZE error: " << record_size << " bytes" << endl;
        return ERROR_CODE;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        errorHandler("fopen() error-12:", file_name);
        return ERROR_CODE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
//                building_double_array = copying_summary;
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                line_count += 1;
                if(line_count > upper_limit) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer);
                building_double_array(n, d); // summary

                p = & n->c[END];
                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); // details

                fwrite(n->c, record_size, 1, binary_file);
            }

        }

    } else {
        if(substituted) {
            dakuten = 'P';
            handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                line_count += 1;
                if(line_count > upper_limit) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer, dakuten, handakuten);
                building_double_array(n, d); // summary

                p = & n->c[END];
                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); // details

                fwrite(n->c, record_size, 1, binary_file);
            }

        }

    }

    delete d;
    fclose(file);
    fclose(binary_file);
    return line_count;
}

int SummaryDetails::selectingAddingID() {
    using namespace std;

    char *p;
    char few_fields;
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    long z = (long)buffer_size;
    Segmented *d = new Segmented(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    FILE *file;
    int buffer_size_1 = buffer_size - 1;
    int dakuten = 0xDE;
    int handakuten = 0xDF;
    int line_count = 0;
    FILE *binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        cerr << "fopen() error-13: " << TEMPORARY_BINARY << endl;
        return ERROR_CODE;
    }

    record_size = END_ID + buffer_size;
    if(record_size > BLOCK_SIZE) {
        cerr << "record_size > BLOCK_SIZE error: " << record_size << " bytes" << endl;
        return ERROR_CODE;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        errorHandler("fopen() error-14:", file_name);
        return ERROR_CODE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
//                building_double_array = copying_summary;
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    n->n[LINE_ID] = line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    n->n[LINE_ID] = line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                line_count += 1;
                if(line_count > upper_limit) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer);
                building_double_array(n, d); // summary

                n->n[LINE_ID] = line_count;
                p = & n->c[END];
                p += WIDE_SPACE_SIZE;

                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); // details

                fwrite(n->c, record_size, 1, binary_file);
            }

        }

    } else {
        if(substituted) {
            dakuten = 'P';
            handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    n->n[LINE_ID] = line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    n->n[LINE_ID] = line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                line_count += 1;
                if(line_count > upper_limit) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer, dakuten, handakuten);
                building_double_array(n, d); // summary

                n->n[LINE_ID] = line_count;
                p = & n->c[END];
                p += WIDE_SPACE_SIZE;

                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); // details

                fwrite(n->c, record_size, 1, binary_file);
            }

        }

    }

    delete d;
    fclose(file);
    fclose(binary_file);
    return line_count;
}

void copying_doubles(DOUBLE_UNION *n, Segmented *d) {
    char *stop;
    int wide_space = strcspn(d->combo, "-.0123456789");
    char *p = & d->combo[wide_space];

    memset(n->c, 0, END);
    for(int k = 0; k < DOUBLE_ARRAY_SIZE; ++k) {
        n->d[k] = strtod(p, &stop);
        p = strchr(p, d->joint);
        if(p == NULL) {
            break;
        }

        p++;
    }

}

void copying_integers(DOUBLE_UNION *n, Segmented *d) {
    char *stop;
    int wide_space = strcspn(d->combo, "-0123456789");
    char *p = & d->combo[wide_space];

    memset(n->c, 0, END);
    for(int k = 0; k < INTEGER_ARRAY_SIZE; ++k) {
        n->n[k] = (int)strtol(p, &stop, 10);
        p = strchr(p, d->joint);
        if(p == NULL) {
            break;
        }

        p++;
    }

}

void copying_summary(DOUBLE_UNION *n, Segmented *d) {
    n->c[END_1] = '\0';
    strncpy(n->c, d->combo, END_1);
}

void errorHandler(const char *p, char *q) {
    using namespace std;

    ofstream file(ERROR_TEXT);
    file << p << GAP << q;
}

void errorHandler(const char *p, int n, const char *q) {
    using namespace std;

    ofstream file(ERROR_TEXT);
    file << p << GAP << n << GAP << q;
}

void Shift_JIS_copying(DOUBLE_UNION *n, Segmented *d) {
    bool kanji = false;
    int c = 0x40;
    int k = 0;
    unsigned char uc;
    unsigned char firstByte = 0x40;

    sjis[END_1] = '\0';
    strncpy(sjis, d->combo, END_1);

    for(int i = 0; sjis[i]; ++i) {
        uc = (unsigned char) sjis[i];
        c = (int)uc;

        if(kanji) {
            n->c[k] = firstByte;
            n->c[ k + 1 ] = (char)uc;
            k += ZENKAKU_SIZE;
            kanji = false;
            continue;
        }

        if(0x81 <= c && c <= 0xFC) {
            if(KANA_KUTEN <= c && c <= KANA_DAKUTEN) {
                n->c[k] = (char)uc;
                k += KATAKANA_SIZE;
            } else {
                firstByte = uc;
                kanji = true;
            }

        } else {
            c = BELL_ASCII_KATAKANA[c];
            if(c == BELL) {
                continue; // skipping control characters
            } else {
                n->c[k++] = (char)uc;
            }

        }

    } // for(int i = 0; sjis[i]; ++i)

    n->c[k] = '\0';
}

void skipping_copying(DOUBLE_UNION *n, Segmented *d) {
    int wide_space = strspn(d->combo, " ");
    char *p = & d->combo[wide_space];

    n->c[END_1] = '\0';
    strncpy(n->c, p, END_1);
}

void skipping_Shift_JIS_copying(DOUBLE_UNION *n, Segmented *d) {
    bool kanji = false;
    int c = 0x40;
    int k = 0;
    unsigned char uc;
    unsigned char firstByte = 0x40;
    int wide_space = strspn(d->combo, " ");
    char *p = & d->combo[wide_space];

    sjis[END_1] = '\0';
    strncpy(sjis, p, END_1);

    for(int i = 0; sjis[i]; ++i) {
        uc = (unsigned char) sjis[i];
        c = (int)uc;

        if(kanji) {
            n->c[k] = firstByte;
            n->c[ k + 1 ] = (char)uc;
            k += ZENKAKU_SIZE;
            kanji = false;
            continue;
        }

        if(0x81 <= c && c <= 0xFC) {
            if(KANA_KUTEN <= c && c <= KANA_DAKUTEN) {
                n->c[k] = (char)uc;
                k += KATAKANA_SIZE;
            } else {
                firstByte = uc;
                kanji = true;
            }

        } else {
            c = BELL_ASCII_KATAKANA[c];
            if(c == BELL) {
                continue; // skipping control characters
            } else {
                n->c[k++] = (char)uc;
            }

        }

    } // for(int i = 0; sjis[i]; ++i)

    n->c[k] = '\0';
}
