#ifndef SUTAI_H // SUmmary and deTAIls (SUTAI)
#define SUTAI_H

#define VERSION 1.22
#define BELL_ASCII_KATAKANA_COUNT 224
#define BLOCK_SIZE 3072
#define BUFFER_SIZE 524288 // 512 KB
#define COMMA ','
#define DOUBLE_ARRAY_SIZE 10
#define MAXIMUM_SIZE_OF_ENCODED_PATTERN 641 // END * 8 bits + 1
#define END 80 // SIZE_OF_DOUBLE * DOUBLE_ARRAY_SIZE = END
#define END_1 79
#define END_ID 91 // END + WIDE_SPACE_SIZE
#define ERROR_TEXT "error.txt"
#define FILE_NAME_SIZE 255
#define HE 0xCD // "" Shift_JIS
#define INTEGER_ARRAY_SIZE 20
#define KANA_DAKUTEN 0xDE
#define KANA_HANDAKUTEN 0xDF
#define KANA_KUTEN 0xA1
#define KATAKANA_SIZE 1
#define LIMIT_OF_MY_MEMORY 128
#define LINE_ID INTEGER_ARRAY_SIZE
#define PATTERN_OF_32_BITS 32
#define RECORD_SIZE BLOCK_SIZE
#define SETTING_TEXT "manager.txt"
#define SIZE_OF_DOUBLE 8 // sizeof(double) = 8
#define SMALL_BUFFER 16
#define SMALL_BUFFER_1 15 // SMALL_BUFFER - 1
#define SUTAI_TEXT "sutai.txt"
#define TEMPORARY_BINARY "binary.tmp"
#define UPPER_LIMIT 16384
#define WIDE_SPACE_SIZE 11 // FINAL_SIZE_1
#define ZENKAKU_SIZE 2
#define ZERO "0"

#ifdef __BORLANDC__
#pragma warn -8004
#pragma warn -8012
#endif // __BORLANDC__

#include "Line.h"
#include "Numbered.h"
#include "Segmented.h"
#include <set>

enum ALLOCATING_PHASES {
    ALLOCATING_BUFFER,
    RECORDS_LIST,
    ALLOCATING_PHASE_COUNT
};

enum LIST_OF_FUNCTIONS {
    PHRASES,
    INTEGERS,
    FLOATING_POINT_NUMBERS,
    FUNCTION_COUNT
};

typedef int (*PHRASES_COMPARING_FUNCTION)(const char *,const char *);

typedef union DOUBLE_UNION DOUBLE_UNION;
union DOUBLE_UNION {
    char c[BLOCK_SIZE];
    double d[DOUBLE_ARRAY_SIZE];
    int n[ INTEGER_ARRAY_SIZE + 1 ];
};

typedef void (*DOUBLE_ARRAY_FUNCTION)(DOUBLE_UNION *n, Segmented *d);

class SummaryDetails {
    bool assume_shift_jis_appears, combining_character, full_house, remove_separators, skip_space, substituted;
    bool add_ID, carriage_return, case_sensitive, descending;
    char *buffer;
    char pattern[ FIELD_COUNT + 1 ]; // bits
    char file_name[ FILE_NAME_SIZE + 1 ];
    char new_name[ FILE_NAME_SIZE + 1 ];
    int buffer_size, dakuten, field_count, joint, handakuten, manager, quote, record_size, separator, upper_limit;

public:
    ~SummaryDetails() {
        delete[] buffer;
    }

    int recordSize() const {
        return record_size;
    }

    int counting();
    int line_for_each_summary();
    int selecting();
    int selectingAddingID();
    SummaryDetails(char *e, char *p, char *w, long z, int s, int f, int j, int m, int q, int u, bool a, bool c, bool r, bool k, bool t, bool i, bool g, bool v, bool n);
};

class Standard_input {
    bool assume_shift_jis_appears, combining_character, full_house, remove_separators, skip_space, substituted;
    bool add_ID, carriage_return, case_sensitive, descending;
    char *buffer;
    char pattern[ FIELD_COUNT + 1 ]; // bits
    int buffer_size, dakuten, field_count, joint, handakuten, manager, quote, record_size, separator, upper_limit;

public:
    ~Standard_input() {
        delete[] buffer;
    }

    int recordSize() const {
        return record_size;
    }

    int standard_input_binary_output();
    int standard_input_binary_output_adding_ID();
    int standard_input_counting();
    int standard_input_line_for_each_summary();
    Standard_input(char *p, long z, int s, int f, int j, int m, int q, int u, bool a, bool c, bool r, bool k, bool t, bool i, bool g, bool v, bool n);
};

bool producing(char *new_name, char *records_list, int end, int line_count, int record_size, bool carriage_return);
char *boolLine(int lineNumber, bool b);
int arranging_to_produce_text(char *file_name, char *new_name, int line_count, int manager, int record_size, bool add_ID, bool carriage_return, bool case_sensitive, bool descending);
int arranging_unique_lines_to_produce_text(char *file_name, char *new_name, int line_count, int manager, int record_size, bool add_ID, bool carriage_return, bool case_sensitive, bool descending);
int case_insensitive_comparison(const void *x, const void *y);
int case_insensitive_comparison_descending(const void *x, const void *y);
int compare_doubles(const void *x, const void *y);
int compare_doubles_descending(const void *x, const void *y);
int compare_integers(const void *x, const void *y);
int compare_integers_descending(const void *x, const void *y);
int compare_phrases(const void *x, const void *y);
int compare_phrases_descending(const void *x, const void *y);
int punctuation(char *p, int q);
int run_length_encoding(DOUBLE_UNION *u, char *combo, int combo_size);
void copying_doubles(DOUBLE_UNION *n, Segmented *d);
void copying_integers(DOUBLE_UNION *n, Segmented *d);
void copying_summary(DOUBLE_UNION *n, Segmented *d);
void display_records(char *records_list, int end, int line_count, int record_size);
void errorHandler(const char *p, char *q);
void errorHandler(const char *p, int n, const char *q);
void producingText(const char *parameters_text, char *file_name, char *new_name, int line_count, int manager, int record_size, bool add_ID, bool case_sensitive, bool report_ID, bool carriage_return, bool descending, bool loud, bool remove_temporary_binary_file, bool unique_summary, bool reduce_binary);
void Shift_JIS_copying(DOUBLE_UNION *n, Segmented *d);
void skipping_copying(DOUBLE_UNION *n, Segmented *d);
void skipping_Shift_JIS_copying(DOUBLE_UNION *n, Segmented *d);
void versionGuide(double v, bool comments, bool loud);

#endif // SUTAI_H
